float3x3 viewMatrix;
float4x4 projectionMatrix;

texture cubeMap;
sampler cubeMapSampler = 
sampler_state
{
	Texture = <cubeMap>;
};

struct VSInput
{
	float4 position				: POSITION;
};

struct VSOutput
{
	float4 position				: POSITION;
	float4 worldSpacePosition	: TEXCOORD0;
};

VSOutput SkyVS(VSInput input)
{
	VSOutput output;
	
	float4 eyeSpacePosition;
	eyeSpacePosition.xyz = mul(input.position.xyz, viewMatrix);
	eyeSpacePosition.w = 1.0f;
	
	output.position				= mul(eyeSpacePosition, projectionMatrix);
	output.worldSpacePosition	= input.position;
	
	return output;
}

struct PSInput
{
	float4 worldSpacePosition	: TEXCOORD0;
};

struct PSOutput
{
	float4 color				: COLOR0;
};

PSOutput SkyPS(PSInput input)
{
	PSOutput output;
	
	output.color = texCUBE(cubeMapSampler, input.worldSpacePosition);
	
	return output;
}

technique SkyTechnique
{
	pass P0
	{
		VertexShader = compile vs_2_0 SkyVS();
		PixelShader = compile ps_2_0 SkyPS();
	}
}
